typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned int u32;

#define REG_DISPCTL *(unsigned short *)0x4000000

#define MODE3 3
#define BG2_ENABLE (1<<10)

#define SCREENWIDTH 240
#define SCREENHEIGHT 160

#define OFFSET(r, c, numcols)  ((r)*(numcols)+(c))

extern unsigned short *videoBuffer;

////////////////////////////////COLOR///////////////////////////////////////////

#define COLOR(r,g,b) ((r) | (g)<<5 | (b)<<10)

#define RED COLOR(31,0,0)
#define BLUE COLOR(0,0,31)
#define GREEN COLOR(0,31,0)
#define CYAN COLOR(0,31,31)
#define MAGENTA COLOR(31,0,31)
#define YELLOW COLOR(31,31,0)
#define BLACK 0
#define WHITE COLOR(31,31,31)

#define SCANLINECOUNTER *(volatile u16 *)0x4000006

//////////////////////////////BRICK STRUCT//////////////////////////////////////

typedef struct brick {

    int row;
    int oldrow;
    int rdel;
    int col;
    int oldcol;
    int cdel;
    int size;

} b;

////////////////////////////FUNCTION PROTOTYPES/////////////////////////////////

void setPixel(int row, int col, u16 color);
void drawRect(int row, int col, int height, int width, u16 color);
void drawHorizLine(int row, int col, int length, u16 color);
void drawVertLine(int row, int col, int length, u16 color);
void drawHollowRect(int row, int col, int height, int width, int thickness, u16 color);
void rasterCircle(int row, int col, int radius, u16 color);
void rasterCircleFace(int row, int col, int radius, u16 color);
void drawStar(int row, int col, int rc, u16 color);
void grid();
void paintScreen(const u16);
void fillScreen(volatile u16);
u16 changeColor();
void clrscr();
void waitForVblank();
void pause();